{******************************************************************}
{                                                                  }
{ DevChange Project                                                }
{ Created by Tom Deprez are                                        }
{ Copyright (C) 1999 Tom Deprez.                                   }
{                                                                  }
{ Contributor(s):                                                  }
{                                                                  }
{                                                                  }
{ Obtained through:                                                }
{                                                                  }
{ Joint Endeavour of Delphi Innovators (Project JEDI)              }
{                                                                  }
{ You may retrieve the latest version of this file at the Project  }
{ JEDI home page, located at http://delphi-jedi.org                }
{                                                                  }
{ The contents of this file are used with permission, subject to   }
{ the Mozilla Public License Version 1.1 (the "License"); you may  }
{ not use this file except in compliance with the License. You may }
{ obtain a copy of the License at                                  }
{ http://www.mozilla.org/MPL/MPL-1.1.html                          }
{                                                                  }
{ Software distributed under the License is distributed on an      }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or   }
{ implied. See the License for the specific language governing     }
{ rights and limitations under the License.                        }
{                                                                  }
{******************************************************************}

unit uDevChange;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DeviceChange, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    DeviceChange1 : TDeviceChange;
    procedure DevChangeArrival(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
    procedure DevChangeQueryRemove(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
    procedure DevChangeQueryRemoveFailed(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
    procedure DevChangeRemoveComplete(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
    procedure DevChangeRemovePending(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
    procedure DevChangeTypeSpecific(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
    procedure DevChangeCustomEvent(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses dbt;
{$R *.DFM}

procedure TForm1.DevChangeArrival(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
var Str : String;
begin
  case ADeviceType of
    dtOEM: Str := 'OEM';
    dtDEVNODE: Str := 'DEVNODE';
    dtVOLUME: Str := 'VOLUME';
    dtPORT: Str := 'PORT';
    dtNET: Str := 'NET';
    dtDEVICEINTERFACE : Str := 'DEVICEINTERFACE';
    dtHANDLE: Str := 'HANDLE';
  end;
  memo1.Lines.Add('Arrival : '+Str);
end;

procedure TForm1.DevChangeQueryRemove(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
var Str : String;
begin
  case ADeviceType of
    dtOEM: Str := 'OEM';
    dtDEVNODE: Str := 'DEVNODE';
    dtVOLUME: Str := 'VOLUME';
    dtPORT: Str := 'PORT';
    dtNET: Str := 'NET';
    dtDEVICEINTERFACE : Str := 'DEVICEINTERFACE';
    dtHANDLE: Str := 'HANDLE';
  end;
  memo1.Lines.Add('QueryRemove : '+Str);
end;

procedure TForm1.DevChangeQueryRemoveFailed(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
var Str : String;
begin
  case ADeviceType of
    dtOEM: Str := 'OEM';
    dtDEVNODE: Str := 'DEVNODE';
    dtVOLUME: Str := 'VOLUME';
    dtPORT: Str := 'PORT';
    dtNET: Str := 'NET';
    dtDEVICEINTERFACE : Str := 'DEVICEINTERFACE';
    dtHANDLE: Str := 'HANDLE';
  end;
  memo1.Lines.Add('QueryRemoveFailed : '+Str);
end;

procedure TForm1.DevChangeRemoveComplete(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
var Str : String;
begin
  case ADeviceType of
    dtOEM: Str := 'OEM';
    dtDEVNODE: Str := 'DEVNODE';
    dtVOLUME: Str := 'VOLUME';
    dtPORT: Str := 'PORT';
    dtNET: Str := 'NET';
    dtDEVICEINTERFACE : Str := 'DEVICEINTERFACE';
    dtHANDLE: Str := 'HANDLE';
  end;
  memo1.Lines.Add('RemoveComplete : '+Str);
end;

procedure TForm1.DevChangeRemovePending(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
var Str : String;
begin
  case ADeviceType of
    dtOEM: Str := 'OEM';
    dtDEVNODE: Str := 'DEVNODE';
    dtVOLUME: Str := 'VOLUME';
    dtPORT: Str := 'PORT';
    dtNET: Str := 'NET';
    dtDEVICEINTERFACE : Str := 'DEVICEINTERFACE';
    dtHANDLE: Str := 'HANDLE';
  end;
  memo1.Lines.Add('RemovePending : '+Str);
end;

procedure TForm1.DevChangeTypeSpecific(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
var Str : String;
begin
  case ADeviceType of
    dtOEM: Str := 'OEM';
    dtDEVNODE: Str := 'DEVNODE';
    dtVOLUME: Str := 'VOLUME';
    dtPORT: Str := 'PORT';
    dtNET: Str := 'NET';
    dtDEVICEINTERFACE : Str := 'DEVICEINTERFACE';
    dtHANDLE: Str := 'HANDLE';
  end;
  memo1.Lines.Add('TypeSpecific : '+Str);
end;

procedure TForm1.DevChangeCustomEvent(Sender: TObject; ADeviceType: TDeviceType; APtr: Pointer);
var Str : String;
begin
  case ADeviceType of
    dtOEM: Str := 'OEM';
    dtDEVNODE: Str := 'DEVNODE';
    dtVOLUME: Str := 'VOLUME';
    dtPORT: Str := 'PORT';
    dtNET: Str := 'NET';
    dtDEVICEINTERFACE : Str := 'DEVICEINTERFACE';
    dtHANDLE: Str := 'HANDLE';
  end;
  memo1.Lines.Add('CustomEvent : '+Str);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DeviceChange1 := TDeviceChange.Create(Self);
  //DeviceChange1.Devices := [dtDEVNODE];
  DeviceChange1.Arrival := DevChangeArrival;
  DeviceChange1.QueryRemove := DevChangeQueryRemove;
  DeviceChange1.QueryRemoveFailed := DevChangeQueryRemoveFailed;
  DeviceChange1.RemoveComplete := DevChangeRemoveComplete;
  DeviceChange1.RemovePending := DevChangeRemovePending;
  DeviceChange1.TypeSpecific := DevChangeTypeSpecific;
  DeviceChange1.CustomEvent := DevChangeCustomEvent;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DeviceChange1.Free;
end;

end.
